#!/usr/local/bin/perl -U

use CGI;			# CGI-paketet till Perl 5.
$query = new CGI;

if ($query->param) {		# Initieringar
    $gammal_text=$query->param('text');
    $slutet=substr($gammal_text,-1);
    if (!($slutet =~ /\n/)) {	# Laegg till newline i slutet om det inte
	$gammal_text .= "\n";	# finns redan
    }
}
$tmpfile1="/tmp/markorA$$";
$tmpfile2="/tmp/markorB$$";

$satsstart="<em>";
$satsslut="</em>";
$ordstart="<strong>";
$ordslut="</strong>";
$kommentarstart="<em>(";
$kommentarslut=")</em>";

chdir("/.hej");

print "Content-type: text/html\n"; # Sidhuvud
print "\n";
print "<body>\n";
print "<title>Markr</title>\n";
print '<img align=left src="runeberg.gif">',"\n";
print "<br><h1>Markr</h1><hr>\n";

print "<h2 align=right>Text</h2>\n"; # Form foer textmassan
print $query->startform;
print $query->textarea('text',$gammal_text,10,80);
print "<br>";
print $query->submit('Kr');
print "<br>\n";
print "<h2>\n";
print "Instllningar\n";
print "</h2>\n";
print "<h3>\n";
print $query->checkbox('Stavningskontroll',$query->param('Stavningskontroll'));
print "</h3>\n";
print "<h3>\n";
print "Srskilda markeringar\n";
print "</h3>\n";
print $query->checkbox('Satsstruktur',$query->param('Satsstruktur'));
print $query->checkbox('Styckesinledare',$query->param('Styckesinledare'));
print $query->checkbox('Mening p egen rad',$query->param('Mening p egen rad'));
print $query->checkbox('Meningsinledare',$query->param('Meningsinledare'));
print $query->checkbox('Funktionsord',$query->param('Funktionsord'));
print $query->checkbox('Innehllsord',$query->param('Innehllsord'));
print $query->checkbox('Negation',$query->param('Negation'));
print "<p>\n";
print "<h3>\n";
print "Norm\n";
print "</h3>\n";
print $query->checkbox('Sats',$query->param('Sats'));
print $query->checkbox('Adjektiv',$query->param('Adjektiv'));
print $query->checkbox('Dubbel passivum',$query->param('Dubbel passivum'));
print $query->checkbox('Dubbel supinum',$query->param('Dubbel supinum'));
print $query->checkbox('Genitiv',$query->param('Genitiv'));
print $query->checkbox('Infinitiv',$query->param('Tempus'));
print $query->checkbox('Pluralform',$query->param('Pluralform'));
print $query->checkbox('Samman-/Srskrivning',$query->param('Samman-/Srskrivning'));
print $query->checkbox('Skiftfel',$query->param('Skiftfel'));
print $query->checkbox('Skiljetecken',$query->param('Skiljetecken'));
print $query->checkbox('Ordmellanrum',$query->param('Ordmellanrum'));
print "<p>\n";
print "<h3>\n";
print "Sprklig stil\n";
print "</h3>\n";
print $query->checkbox('Adverbial',$query->param('Adverbial'));
print $query->checkbox('Prepositionsmte',$query->param('Prepositionsmte'));
print $query->checkbox('Sprklig sknhet',$query->param('Sprklig sknhet'));
print $query->checkbox('Dubbel negation',$query->param('Dubbel negation'));
print $query->checkbox('Hgtidligt sprk',$query->param('Hgtidligt sprk'));
print $query->checkbox('Talsprk',$query->param('Talsprk'));
print $query->checkbox('Tempus',$query->param('Tempus'));
print $query->checkbox('Tillkrnglat sprk',$query->param('Tillkrnglat sprk'));
print $query->checkbox('Presens particip',$query->param('Presens particip'));
print $query->checkbox('Presens passivum',$query->param('Presens passivum'));
print "<p>\n";
print "<h3>\n";
print $query->checkbox('Ordklasser',$query->param('Ordklasser'));
print "</h3>\n";
print $query->endform;
print "<hr>";
if (length($gammal_text) <= 5) { # Om textmassan foer kort: laegg av
    exit;
};
if (length($gammal_text) >= 5000) { # Om texten foer laang: trunkera
    $gammal_text = substr($gammal_text,5000);
}

if ($query->param('Stavningskontroll')) {
    open(STAVNING,"|./etc/stava -eafnsr8 > $tmpfile1");
    print STAVNING $gammal_text;
    close(STAVNING);
    open(STAVADTEXT,"$tmpfile1");
    @stavadtext=<STAVADTEXT>;
    close(STAVADTEXT);
    unlink $tmpfile1;
    $gammal_fnutt=$";		# Slaetar ut
    $"="";
    $stavadtext="@stavadtext";
    $"=$gammal_fnutt;
    print "<h2>Stavning</h2>\n";
    $stavadtext =~ s/\n/<br>\n/g; # Radbrytning aeven i html
    print "<h3>Felstavade ord</h3>$stavadtext","</b>\n";
    print "<hr>\n";
}

open(TAGGNING,"|./etc/ma -r ./etc/swedish.ma > $tmpfile1"); # Goer grundtaggning
print TAGGNING $gammal_text;
close(TAGGNING);
open(TAGGADTEXT,"$tmpfile1");
@taggadtext=<TAGGADTEXT>;
close(TAGGADTEXT);
unlink $tmpfile1;

$gammal_fnutt=$";		# Slaetar ut
$"="";
$taggadtext="@taggadtext";
$"=$gammal_fnutt;

$taggadtext =~ s/\n/<br>\n/g;	# Radbrytning aeven i html

$markeringar = $query->param('Satsstruktur')
    || $query->param('Funktionsord')
    || $query->param('Innehllsord')
    || $query->param('Negation')
    || $query->param('Mening p egen rad')
    || $query->param('Meningsinledare')
    || $query->param('Styckesinledare')
    ;
if ($markeringar) {		# Om skall utfoeras naagra markeringar alls
    $_=$taggadtext;
    if ($query->param('Satsstruktur')) {
	s/[Kr].[^]+../$ordstart$&$ordslut/g;	# Konjunktioner
	s/[^o].[^]+/$ordstart$&$ordslut/g; # Skiljetecken
    }
    if ($query->param('Funktionsord')) {
	s/[fghFGHKRrEDQAiMKEBabc].[^]+../$ordstart$&$ordslut${kommentarstart}F$kommentarslut/g;
    }
    if ($query->param('Innehllsord')) {
	s/[^fghFGHKRrEDQAiMKEBabc].[^]+../$ordstart$&$ordslut${kommentarstart}I$kommentarslut/g;
    }
    if ($query->param('Negation')) {
	s/..(inte|ej|icke|varken|minst|knappast|utan|sakna(r|de|t)?s?|(o(a|b[aeiloruy]|d[eijoruy]|e|f[aeijoru]|g|h|i|j|k|l[aouy]|n[ou]|o|p[alorsu]|r[u]|s[^t]|t[^t]|u|v|||)|im|ir|ill|miss|van|dis|kvasi|icke|non)[^]*[aoueiy][^]+)../$ordstart$&$ordslut${kommentarstart}Neg$kommentarslut/g;
    }
    if ($query->param('Mening p egen rad')) {
	s/[sm].[^]+../$&<br>/g;
    }
    if ($query->param('Meningsinledare')) {
	s/([sm].[^]+|^)(..[^]+)/\1$ordstart\2$ordslut/g;
    }
    if ($query->param('Styckesinledare')) {
	s/(s.[^]+|m.[^\n]*\n[^\n]*|^)((..[^]+[^m].[^]+)*..[^]+[sm].[^]+)/\1$satsstart\2$satsslut/g;
    }
    s/..//g;			# Ta bort det som inte anvaents
    s/..//g;
    s/$ordstart$satsslut/$satsslut$ordstart/g;
    s/$satsstart$ordslut/$ordslut$satsstart/g;
    s/$ordstart$satsstart/$satsstart$ordstart/g;
    s/$satsslut$ordslut/$ordslut$satsslut/g;
    $markeradtext=$_;
    print "<h2>Markerad text</h2>\n";
    print $markeradtext;
    print "<hr>\n";
}
%verbal = ('Felaktig adjektivbjning','Predikativet skall inte sluta p -t.',
	   'Felaktig komparation','Komparera med mer eller mest i stllet.',
	   'Dubbel komparation','Komparera med ndelse <em>eller</em> mer/mest.',
	   'Adverbialkedja','Alltfr mnga adverbial i en kedja gr texten svrlst.',
	   'Dubbel negation','Vanligen tar tv negationer ut varandra.',
	   'Dubbel passivum','Bgge verben skall inte st i passivum.',
	   'Dubbel supinum','Det senare av de bgge verben skall inte st i supinum-form.',
	   'Gruppgenitiv','Det anses numera bttre att sga '
		.'"Kungen av Danmarks brstkarameller" '
		. ' n "Kungens av Danmark brstkarameller".',
	   'Engelsk genitiv','Svensk genitiv form skrivs utan \'.',
	   'Genitiv saknas','Skall inte egennamnet vara i genitivform?',
	   'Konsekvens - hgtidligt','Var konsekvent vad gller '
		.'verbformer, hgtidligt, t.ex. taga, gentemot lite '
		.'mer normalt, t.ex. ta.',
	   'Konsekvens - talsprk','Var konsekvent vad gller '
		.'verbformer, talsprk, t.ex. dan, gentemot lite '
		.'mindre ledigt, t.ex. dagen.',
	   'Infinitivmrke saknas','Ett infinitiv skall normal '
		.'fregs av ett infintivmrke "att" eller ett '
		.'hjlpverb som t.ex. "kan".',
	   'Tillkrnglat ord','Detta ord kan ofta ersttas med ett '
		.'enklare och kortare ord.',
	   'Dubbelt mellanrum','Dubbelt mellanrum r ofta resultatet '
		.'att fingrarna slinter p tangentbordet.',
	   'Mellanrum fre skiljetecken','Fre detta skiljetecken skall '
		.'det inte vara mellanrum.',
	   'Mellanrum efter skiljetecken','Efter detta skiljetecken skall '
		.'det inte vara mellanrum.',
	   'Inget mellanrum fre skiljetecken','Fre detta skiljetecken '
		.'skall det vara mellanrum.',
	   'Inget mellanrum efter skiljetecken','Efter detta skiljetecken '
		.'skall det vara mellanrum.',
	   'Mellanrum omkring skiljetecken','Kring detta skiljetecken skall '
		.'det inte vara mellanrum p bda sidor.',
	   'Hopning av skiljetecken','Detta r ingen lmplig kombination '
		.'av skiljetecken.',
	   'Felaktig pluralform','Detta r en pluralform, inte singular.',
	   'Prepositionsmte','Flera prepositioner i rad brukar sllan '
		.'fungera bra.',
	   'Presens particip','Presens particip-former gr ofta texten '
		.'mer tunglst. Skriv enkel presens, t.ex. '
		.'"sjunger" i stllet fr "r sjungande".',
	   'Presens passivum','Presens passivum skrivs ofta hellre med '
		.'-s i stllet fr -es, t.ex. "skrivs" i stllet fr "skrives".',
	   'Sammanskrivet ord','Detta sammanskrivna ord br delas upp '
		.'som flera ord.',
	   'Srskrivet ord','Detta srskrivna ord skrivs normal enbart som '
		.'ett enda ord.',
	   'Ofullstndig sats','Denna sats frefaller inte innehlla ngot '
		.'verb.',
	   'Skiftfel','Kombinationen av sm och stora bokstver i detta ord '
		.'r inte normal.',
	   'Vokalmte','Samma vokal i slutet av ett ord och i brjan av '
		.'nsta ger inte alltid s bra uttal.',
	   );
$granskningar = $query->param('Adjektiv')
    || $query->param('Adverbial')
    || $query->param('Dubbel negation')
    || $query->param('Dubbel passivum')
    || $query->param('Dubbel supinum')
    || $query->param('Genitiv')
    || $query->param('Hgtidligt sprk')
    || $query->param('Talsprk')
    || $query->param('Tempus')
    || $query->param('Infinitiv')
    || $query->param('Tillkrnglat sprk')
    || $query->param('Ordmellanrum')
    || $query->param('Skiljetecken')
    || $query->param('Pluralform')
    || $query->param('Prepositionsmte')
    || $query->param('Presens particip')
    || $query->param('Presens passivum')
    || $query->param('Samman-/Srskrivning')
    || $query->param('Sats')
    || $query->param('Skiftfel')
    || $query->param('Sprklig sknhet')
    ;
if ($granskningar) {		# Om skall utfoeras naagra granskningar alls
    $_=$taggadtext;
    if ($query->param('Adjektiv')) {
	$traeffar{"Felaktig adjektivbjning"} += s/(N.[^]+o.[^]+[afF].[^]+o.[^]+)(J.[^]+t)(..[^]+)/\1$ordstart\2$ordslut${kommentarstart}Felaktig adjektivbjning${kommentarslut}\3/g;
        $traeffar{"Felaktig komparation"} += s/J.([a-z]+[aoueiy][^]+(ande?|ende?|sk|samm?|ad)|[a-z]*[aoueiy][a-z]*[aoueiy][a-z]*[aoueiy][a-z]*[aoueiy][a-z]*)(are|aste?)../$ordstart$&$ordslut${kommentarstart}Felaktig komparation$kommentarslut/g;
        $traeffar{"Dubbel komparation"} += s/..(mer|mest)o.[^]+(..[^]+o.[^]+)?..[^]+(are|aste?)../$ordstart$&$ordslut${kommentarstart}Dubbel komparation$kommentarslut/g;
    }
    if ($query->param('Adverbial')) {
	$traeffar{"Adverbialkedja"} += s/(.P[^]+([QJ][^S][^]+)*.S[^]+|A.[^]+)[^ksm].[^]+((.P[^]+([QJ][^S][^]+)*.S[^]+|A.[^]+)[^ksm].[^]+)+(.P[^]+([QJ][^S][^]+)*.S[^]+|A.[^]+)../$ordstart$&$ordslut${kommentarstart}Adverbialkedja$kommentarslut/g;
    }
    if ($query->param('Dubbel negation')) {
	$traeffar{"Dubbel negation"} += s/..(inte|ej|icke|varken|minst|knappast|utan|sakna(r|de|t)?s?)o.[^]+(..[^]+o.[^]+)?(..[^]+o.[^]+)?..(inte|ej|icke|varken|minst|knappast|utan|sakna(r|de|t)?s?|(o(a|b[aeiloruy]|d[eijoruy]|e|f[aeijoru]|g|h|i|j|k|l[aouy]|n[ou]|o|p[alorsu]|r[u]|s[^t]|t[^t]|u|v|||)|im|ir|ill|miss|van|dis|kvasi|icke|non)[^]*[aoueiy][^]+)../$ordstart$&$ordslut${kommentarstart}Dubbel negation$kommentarslut/g;
    }
    if ($query->param('Dubbel passivum')) {
	$traeffar{"Dubbel passivum"} += s/([ghvUIHGbc].[^]+so.[^]+([^K].[^]+o.[^]+)?[ghvUIHGbc].[^]+s..|[vUI].[^]+so.[^]+([^KM].[^]+o.[^]+)?[I0].[^]+..)/$ordstart$&$ordslut${kommentarstart}Dubbel passivum$kommentarslut/g;
    }
    if ($query->param('Dubbel supinum')) {
	$traeffar{"Dubbel supinum"} += s/(G.[^]+t|U.[^]+)o.[^]+([^K].[^]+o.[^]+)?U.[^]+../$ordstart$&$ordslut${kommentarstart}Dubbel supinum$kommentarslut/g;
    }
    if ($query->param('Genitiv')) {
	$traeffar{"Engelsk genitiv"} += s/[LN].[^]+..[']..s../$ordstart$&$ordslut${kommentarstart}Engelsk genitiv$kommentarslut/g;
	$traeffar{"Gruppgenitiv"} += s/O.[^]+o.[^]+[EB].[^]+o.[^]+[LN].[^]+../$ordstart$&$ordslut${kommentarstart}Gruppgenitiv$kommentarslut/g;
	$traeffar{"Genitiv saknas"} += s/(L.[^]+[^s])(o.[^]+N.[^]+..)/$ordstart\1$ordslut${kommentarstart}Genitiv saknas$kommentarslut\2/g;
    }
#verb-konsekvens-2konsekvens[HIF0].[^]*(bli|ge|ha|ta)...+[IHF].[^]*(bliva|giva|hava|taga)..|[HIF0].[^]*(bliva|giva|hava|taga)...+[IHF].[^]*(bli|ge|ha|ta)..[HIF0].[^]*(bliva|giva|hava|taga|bli|ge|ha|ta)..Hgtidligt/Modernt sprkordmarkering
     if ($query->param('Hgtidligt sprk')) {
	$traeffar{"Konsekvens - hgtidligt"} += s/([HIF0].[^]*(bliva|giva|hava|taga)..)(.+)([HIF0].[^]*(bli|ge|ha|ta)..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - hgtidligt$kommentarslut\3$ordstart\5$ordslut${kommentarstart}Konsekvens - hgtidligt$kommentarslut/g;
	$traeffar{"Konsekvens - hgtidligt"} += s/([HIF0].[^]*(bli|ge|ha|ta)..)(.+)([HIF0].[^]*(bliva|giva|hava|taga)..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - hgtidligt$kommentarslut\3$ordstart\5$ordslut${kommentarstart}Konsekvens - hgtidligt$kommentarslut/g;
    }
    if ($query->param('Talsprk')) {
	$traeffar{"Konsekvens - talsprk"} += s/(..(nn|sn|sen)..|..([^]*[aoueiy][^]*)?(dan|stan)..)(.+)(..(ngon|sdan|sedan)..|..([^]*[aoueiy][^]*)?(dagen|staden)..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\5$ordstart\6$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(..(ngon|sdan|sedan)..|..([^]*[aoueiy][^]*)?(dagen|staden)..)(.+)(..(nn|sn|sen)..|..([^]*[aoueiy][^]*)?(dan|stan)..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\5$ordstart\6$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(..[mds]ig..)(.+)(..[mds]ej..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(..[mds]ej..)(.+)(..[mds]ig..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(..dem?..)(.+)(..dom..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(..dom..)(.+)(..dem?..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(..ska..)(.+)(..skall..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(..skall..)(.+)(..ska..)/$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(v.(la|([^]*[aoueiy][^]*)?sa))..(.+)(v.(lade|([^]*[aoueiy][^]*)?sade))../$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\4$ordstart\5$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;
	$traeffar{"Konsekvens - talsprk"} += s/(v.(lade|([^]*[aoueiy][^]*)?sade))..(.+)(v.(la|([^]*[aoueiy][^]*)?sa))../$ordstart\1$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut\4$ordstart\5$ordslut${kommentarstart}Konsekvens - talsprk$kommentarslut/g;

    }
    if ($query->param('Tempus')) {
	$traeffar{"Konsekvens - tempus"} += s/([fghv].[^]+)(.+)([abcV].[^]+)/$ordstart\1$ordslut${kommentarstart}Konsekvens - tempus$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - tempus$kommentarslut/g;
	$traeffar{"Konsekvens - tempus"} += s/([abcV].[^]+)(.+)([fghv].[^]+)/$ordstart\1$ordslut${kommentarstart}Konsekvens - tempus$kommentarslut\2$ordstart\3$ordslut${kommentarstart}Konsekvens - tempus$kommentarslut/g;
    }

    if ($query->param('Infinitiv')) {
	$traeffar{"Infinitivmrke saknas"} += s/(^|[ksm].[^]+)([^MGgb].[^]+o.[^]+)*(I.[^]+)../\1\2$ordstart\3$ordslut${kommentarstart}Infinitivmrke saknas$kommentarslut/g;
    }
    if ($query->param('Tillkrnglat sprk')) {
	$traeffar{"Tillkrnglat ord"} += s/([UvVI][^]*[aoueiy][^]*(ivisera|iktiga)[^]*|..[^]*[aoueiy][^]*(aktivitet|beteende|bild|enhet|funktion|frfarande|hll|komponent|lge|niv|process|ram|resurs|sektor|sida|situation|struktur|stllning|system|verksamhet)(en|n|t|et)?(er|ar|ena|na|erna|arna)?s?|..(an|av|be|bort|efter|er|ex|fort|fram|frn|fre|fr|genom|hn|hr|inne|in|i|med|mot|ned|ner|om|p|samman|till|undan|under|uppe|upp|ur|utan|ut|ver|ter|t)[a-z]*[aoueiy][^]+((het|ing)(en|er|erna)?s?|ande(t|n|ena)?s?))../$ordstart$&$ordslut${kommentarstart}Tillkrnglat ord$kommentarslut/g;
    }
    if ($query->param('Ordmellanrum')) {
	$traeffar{"Dubbelt mellanrum"} += s/..  +../$ordstart$&$ordslut${kommentarstart}Dubbelt mellanrum$kommentarslut/g;
    }
    if ($query->param('Skiljetecken')) {
	$traeffar{"Mellanrum fre skiljetecken"} += s/.. +([!\?]([^!\?]|..)|[\);,:\.])/$ordstart$&$ordslut${kommentarstart}Mellanrum fre skiljetecken$kommentarslut/g; # Mellanrum foere skiljetecken
	$traeffar{"Inget mellanrum efter skiljetecken"} += s/(..([\?!]+|;)(..|[^ ~"])|..,([^ ]|[^Q].)|m.\...|..[:\)][^Q].)[;\?!,\.:\)\-]/$ordstart$&$ordslut${kommentarstart}Inget mellanrum efter skiljetecken$kommentarslut/g; #Inget mellanrum efter skiljetecken
	$traeffar{"Inget mellanrum fre skiljetecken"} += s/..\(/$ordstart$&$ordslut${kommentarstart}Inget mellanrum fre skiljetecken$kommentarslut/g;#Inget mellanrum foere skiljetecken
	$traeffar{"Mellanrum efter skiljetecken"} += s/\( +../$ordstart$&$ordslut${kommentarstart}Mellanrum efter skiljetecken$kommentarslut/g;#Mellanrum efter skiljetecken
	$traeffar{"Mellanrum omkring skiljetecken"} += s/..[^]+"[^]+../$ordstart$&$ordslut${kommentarstart}Mellanrum omkring skiljetecken$kommentarslut/g; #Mellanrum baade foere och efter skiljetecken
	$traeffar{"Mellanrum omkring skiljetecken"} += s/..[^]+"[^]+../$ordstart$&$ordslut${kommentarstart}Mellanrum omkring skiljetecken$kommentarslut/g; #Mellanrum baade foere och efter skiljetecken
	$traeffar{"Hopning av skiljetecken"} += s/((..|[^\.])\.\.([^\.]|..)|\.\.\.\.+..|[&;:,=+\-][&;:,=+\-\.\?!]+)/$ordstart$&$ordslut${kommentarstart}Hopning av skiljetecken$kommentarslut/g;
    }
    if ($query->param('Pluralform')) {
	$traeffar{"Felaktig pluralform"} += s/(..(ett|ngot|inget|detta)o.[^]+(..[^]+o.[^]+)?..(data|centra|fakta|fora|futura|kuriosa|media)..|..(datat|centrat|faktat|forat|futurat|kuriosat|mediat)..)/$ordstart$&$ordslut${kommentarstart}Felaktig pluralform$kommentarslut/g;
    }
    if ($query->param('Prepositionsmte')) {
	$traeffar{"Prepositionsmte"} += s/([BE][^]+o.[^]+)+[BE][^]+../$ordstart$&$ordslut${kommentarstart}Prepositionsmte$kommentarslut/g;
    }
    if ($query->param('Presens particip')) {
	$traeffar{"Presens particip"} += s/[afF].[^]+o.[^]+((.P[^]+([QJ][^S][^]+)*.S[^]+|[AJ].[^]+)o.[^]+)*..[^]*[aoueiy][^]*[ae]nde../$ordstart$&$ordslut${kommentarstart}Presens particip$kommentarslut/g;
    }
    if ($query->param('Presens passivum')) {
	$traeffar{"Presens passivum"} += s/[VUIHGbc].[a-z]+es../$ordstart$&$ordslut${kommentarstart}Presens passivum$kommentarslut/g;
    }

    if ($query->param('Samman-/Srskrivning')) {
	$traeffar{"Sammanskrivet ord"} += s/[vVUI].((av|bort|dit|efter|fast|fel|fram|genom|hem|hit|hop|in|jmn|kvar|ls|med|mot|ned|ner|om|p|ren|samman|snder|undan|upp|ur|ut|vid|kring|till|helig|hemlig|hdan|hn|istnd|isr|klar|kull|ledig|loss|verens)[^]*[aoueiy][^]*|[^]*[aoueiy][^]*(gra?|gjor(de|t)|(frklara|mla|betsa|frga)(r|de|t)?))../$ordstart$&$ordslut${kommentarstart}Sammanskrivet ord$kommentarslut/g;
	$traeffar{"Sammanskrivet ord"} += s/..(akter(ifrn|om|ut)|allra(bst|frmst|frst|helst|hgst|minst)|allt(bttre|eftersom|fler|merochmer|som(..[^]+)*oftast)|dess(bttre|vrre)|dfr(..[^]+)*tiden|dr(bakom|borta|bortom|bredvid|framme|frbi|hemma|ikring|ini|inifrn|innanfr|inne|inom|intill|inunder|inuti|invid|nedan|nedanfr|nedifrn|nere|nerifrn|omkring|ovan|uppe|uppifrn|utanfr|ute|utifrn|utmed|utomkring|utmed)|efterhand|enface|engros|enpassant|ettervrre|framfrallt|fulltut|fr(all(..[^]+)*del|den(..[^]+)*skull|handen|hnder|ifrn|nr|om|(..[^]+)*svitt|tidigt|ut|ver|vrigt|edetta)|god(dag|natt|morgon|kvll|afton|middag|natt)|hartnra?|heltvisst|i(akt|gr|dag|r|fjol|morgon|fred|frga|gng|kapp|kraft|kras|land|styr|stnd|stllet|synnerhet|vg|vrigt)|medens|mitt(emellan|inne|p|under|upp|ver)|nogav|nu(..[^]+)*frtiden|nufr(..[^]+)*tiden|nranog|nst(efter|intill|invid)|om(hand|hnder|intet)|p(nytt|vg)|rent(av|ut|utav)|runt(ikring|om|omkring)|spik(nykter|full)|splitt[a-z]+|spritt[a-z]+|s(hr|dr|ja|pass|nr(..[^]+)*som)|tidsnog|till(buds|dels|dess|finnandes|freds|fullo|fyllest|fnga|godo|handa|hands|knna|mtes|pass|reds|rygga|rtta|sinnes|sist|spillo|vara|viljes|vga|nda|ventyrs|vers|svidare)|tvrs(igenom|ver)|tvrtigenom|underhand|uppochner[rd][a-z]*|urstnd|utochin[a-z]*|var(sin|sitt|sina)|frde|ver(bord|huvud((..[^]+)*taget)?|hvan|lag|nog|stag|styr|stv|sig(..[^]+)*given))../$ordstart$&$ordslut${kommentarstart}Sammanskrivet ord$kommentarslut/g;
	$traeffar{"Srskrivet ord"} += s/..(allt..[^]+..(efter(som)?|emellant|fort|fr|ifrn|igenom|ihop|intill|mera?|nog|sedan)|apro..[^]+..p|bort..[^]+..emot|dess..[^]+..frinnan|dess(..[^]+..)?fr..[^]+..innan|drvid..[^]+..lag|(en|ett)..[^]+..var|fr..[^]+..(utom|visso)|gente..[^]+..mot|hittill..[^]+..dags|hrom..[^]+..(dagen|kvllen|natten|sistens|ret)|hrvid..[^]+..|hr(..[^]+..)?vid..[^]+..lag|i..[^]+..(hjl|hop|hg|sr|tu)|in..[^]+..emot|engen..[^]+..stans|lika..[^]+..fullt|lik..[^]+..vl|norr..[^]+..(ifrn|ut)|nutill..[^]+..dags|nu(..[^]+..)?till..[^]+..dags|ngon..[^]+..stans|nra..[^]+..p|s..[^]+..(vitt|vl)|sder..[^]+..(ifrn|ut)|tvrt..[^]+..(emot|om)|upp..[^]+..emot|var..[^]+..stans|visa..[^]+..vi|vster..[^]+..(ifrn|ut)|..[^]+..(sido|nyo)|ter..[^]+..igen|ster..[^]+..(ifrn|ut)|ver..[^]+..allt)../$ordstart$&$ordslut${kommentarstart}Srskrivet ord$kommentarslut/g;
    }
    if ($query->param('Sats')) {
	$traeffar{"Ofullstndig sats"} += s/(^|[sm].[^]+)([^fghvFGHVIabc].[^]+o.[^]+)*[^fghvFGHVI].[^]+($|[sm].[^]?)/$satsstart$&$satsslut${kommentarstart}Ofullstndig sats$kommentarslut/g;
    }
    if ($query->param('Skiftfel')) {
	$traeffar{"Skiftfel"} += s/..(([^]*[a-z][A-Z][^]*)|([A-Z][A-Z]+[a-z][^]*))../$ordstart$&$ordslut${kommentarstart}Skiftfel$kommentarslut/g;
    }
    if ($query->param('Sprklig sknhet')) {
	$traeffar{"Vokalmte"} += s/..[^]*(ao.[^]+..a|oo.[^]+..o|uo.[^]+..u|o.[^]+..|eo.[^]+..e|io.[^]+..i|yo.[^]+..y|o.[^]+..|o.[^]+..)[^]*../$ordstart$&$ordslut${kommentarstart}Vokalmte$kommentarslut/g;
    }
#    if ($query->param('')) {
#	$traeffar{""} += s//$ordstart$&$ordslut${kommentarstart}$kommentarslut/g;
#    }
#    if ($query->param('')) {
#	$traeffar{""} += s//$ordstart$&$ordslut${kommentarstart}$kommentarslut/g;
#    }
#    if ($query->param('')) {
#	$traeffar{""} += s//$ordstart$&$ordslut${kommentarstart}$kommentarslut/g;
#    }
#    if ($query->param('')) {
#	$traeffar{""} += s//$ordstart$&$ordslut${kommentarstart}$kommentarslut/g;
#    }
#    if ($query->param('')) {
#	$traeffar{""} += s//$ordstart$&$ordslut${kommentarstart}$kommentarslut/g;
#    }
    s/..//g;			# Ta bort det som inte anvaents
    s/..//g;
    s/$ordstart$satsslut/$satsslut$ordstart/g;
    s/$satsstart$ordslut/$ordslut$satsstart/g;
    s/$ordstart$satsstart/$satsstart$ordstart/g;
    s/$satsslut$ordslut/$ordslut$satsslut/g;
    $granskadtext=$_;
    print "<h2>Granskning</h2>\n";
    print "<h3>Granskad text</h3>\n";
    print $granskadtext,
#	$taggadtext
	;
    print "<h3>Kommentarer</h3>\n";
    print "<table><tr><th>Namn</th><th>Kommentar</th></tr>\n";
    while(($komm,$ver) = each(%verbal)) {
	if ($traeffar{$komm}) {
	    print "<tr><td>",$komm,"</td><td>",
	    $ver,"</td></tr>\n";
 	}
    }
    print "<\/table>\n";
    print "<hr>\n";
}
if ($query->param('Ordklasser')) { # Ordklasser skall analyseras
    # Rubriktaggar
    @rubrik=('Oknt','Adverb','Partikel','Bestmning','Preposition','Kopula',
	     'Hjlpverb','Inifinitiv','Adjektiv','Konjunktion',	# 
	     'Egennamn','Infinitivmrke','Substantiv','Possesiv','Kvantifierare',
	     'Pronomen','Verb','Interjektion','Blandord',
	     'Versalord','Frkortning');
    $_=$taggadtext;
    $antal[20]=s/..([^]+(t.\. ?..[^][^]?[^]?)*t.\. ?)/<\/b><font size=-2>$rubrik[20]<\/font><b>\1/g;
    s/..//g; 			# Laesbara taggar:
    $antal[0]=s/0./<\/b><font size=-2><\/font><b>/g;
    $antal[1]=s/A./<\/b><font size=-2>$rubrik[1]<\/font><b>/g;
    $antal[2]=s/B./<\/b><font size=-2>$rubrik[2]<\/font><b>/g;
    $antal[3]=s/D./<\/b><font size=-2>$rubrik[3]<\/font><b>/g;
    $antal[4]=s/E./<\/b><font size=-2>$rubrik[4]<\/font><b>/g;
    $antal[5]=s/F./<\/b><font size=-2>$rubrik[5]<\/font><b>/g;
    $antal[5]+=s/a./<\/b><font size=-2>$rubrik[5]<\/font><b>/g;
    $antal[5]+=s/f./<\/b><font size=-2>$rubrik[5]<\/font><b>/g;
    $antal[6]=s/G./<\/b><font size=-2>$rubrik[6]<\/font><b>/g;
    $antal[6]+=s/H./<\/b><font size=-2>$rubrik[6]<\/font><b>/g;
    $antal[6]+=s/g./<\/b><font size=-2>$rubrik[6]<\/font><b>/g;
    $antal[6]+=s/h./<\/b><font size=-2>$rubrik[6]<\/font><b>/g;
    $antal[6]+=s/b./<\/b><font size=-2>$rubrik[6]<\/font><b>/g;
    $antal[6]+=s/c./<\/b><font size=-2>$rubrik[6]<\/font><b>/g;
    $antal[7]=s/I./<\/b><font size=-2>$rubrik[7]<\/font><b>/g;
    $antal[8]=s/J./<\/b><font size=-2>$rubrik[8]<\/font><b>/g;
    $antal[9]=s/K./<\/b><font size=-2>$rubrik[9]<\/font><b>/g;
    $antal[10]=s/L./<\/b><font size=-2>$rubrik[10]<\/font><b>/g;
    $antal[11]=s/M./<\/b><font size=-2>$rubrik[11]<\/font><b>/g;
    $antal[12]=s/N./<\/b><font size=-2>$rubrik[12]<\/font><b>/g;
    $antal[13]=s/O./<\/b><font size=-2>$rubrik[13]<\/font><b>/g;
    $antal[14]=s/Q./<\/b><font size=-2>$rubrik[14]<\/font><b>/g;
    $antal[15]=s/R./<\/b><font size=-2>$rubrik[15]<\/font><b>/g;
    $antal[16]=s/U./<\/b><font size=-2>$rubrik[16]<\/font><b>/g;
    $antal[16]+=s/V./<\/b><font size=-2>$rubrik[16]<\/font><b>/g;
    $antal[17]=s/i./<\/b><font size=-2>$rubrik[17]<\/font><b>/g;
    $antal[18]=s/l./<\/b><font size=-2>$rubrik[18]<\/font><b>/g;
    $antal[19]=s/q./<\/b><font size=-2>$rubrik[19]<\/font><b>/g;
    $antal[15]+=s/r./<\/b><font size=-2>$rubrik[15]<\/font><b>/g;
    $antal[16]+=s/v./<\/b><font size=-2>$rubrik[16]<\/font><b>/g;
    $antal[12]+=s/W./<\/b><font size=-2>$rubrik[12]<\/font><b>/g;
    $ordkltext=$_;
    
				# Presentation av ordklasser
    print "<h2>Ordklasser</h2>\n";
    print "<h3>Ordklassmarkeringar</h3>$ordkltext","</b>";
    print "<h3>Frekvenser</h3>\n";
    print "<table><tr><th>Ordklass</th><th>Antal</th></tr>\n";
    for ($i=1;$i<=20;$i++) {
	if ($antal[$i]) {
	    print "<tr><td>",$rubrik[$i],"</td><td align=center>",
	    $antal[$i],"</td></tr>\n";
	}
    }
}
print "</table>";
print "</body>\n";

